/* File name : dcg.pl */

complex_sentence-->sentence.
complex_sentence-->sentence,coord_conj_is(X),sentence.
complex_sentence-->sentence,coord_conj_is(X),verb_prep_phrase(X).
complex_sentence-->sentence,coord_conj_is(X),verb_prep_phrase(X),
	coord_conj_is(X),verb_prep_phrase(X).

sentence-->noun_phrase(X),verb_prep_phrase(X).

noun_phrase(X)-->noun_adj_group(X).
noun_phrase(X)-->propernoun_is(X).
noun_phrase(X)-->adjective_is(X).
noun_phrase(X)-->pronoun_is(X).
noun_phrase(X)-->adjective_is(X), propernoun_is(X).
noun_phrase(X)-->determiner_is(X),noun_adj_group(X). 
noun_phrase(X)-->genitive_is(X),noun_adj_group(X).
noun_phrase(X)-->adverbial_phrase(X).
noun_phrase(X)-->[SENT], {register_unknown(SENT),register('Fail in noun_phrase',SENT),fail}.

noun_adj_group(X)-->adjective_is(X), noun_is(X).
noun_adj_group(X)-->noun_is(X).

verb_prep_phrase(X)-->verb_phrase(X).
verb_prep_phrase(X)-->verb_phrase(X), prepositional_phrase(X).
verb_prep_phrase(X)-->verb_phrase(X), prepositional_phrase(X), prepositional_phrase(X).

verb_group(X)-->verb_is(X).
verb_group(X)-->verb_is(X),participle_is(X).
verb_group(X)-->verb_is(X),pronoun_is(X),participle_is(X).
verb_group(X)-->[VERB], {register_unknown(VERB),register('Fail in verb_phrase',VERB),fail}.

verb_phrase(X)-->verb_group(X).
verb_phrase(X)-->verb_group(X),noun_phrase(X).
verb_phrase(X)-->verb_group(X),noun_phrase(X),verb_group(X).
verb_phrase(X)-->verb_group(X),prepositional_phrase(X),infinitive_is(X).
verb_phrase(X)-->verb_group(X),prepositional_phrase(X),coord_conj_is(X),prepositional_phrase(X).
verb_phrase(X)-->verb_group(X),infinitive_is(X),noun_phrase(X).
verb_phrase(X)-->verb_group(X),infinitive_is(X),prepositional_phrase(X).

prepositional_phrase(X)-->adverbial_phrase(X).
prepositional_phrase(X)-->preposition_is(X).
prepositional_phrase(X)-->preposition_is(X),noun_phrase(X).
prepositional_phrase(X)-->[PREPOSITION], {register_unknown(SENT),register('Fail in prepositonal_phrase',PREPOSITION),fail}.

adverbial_phrase(X)-->adverbial_is(X).
adverbial_phrase(X)-->adverbial_is(X),noun_phrase(X).
adverbial_phrase(X)-->[ADVERBIAL], {register_unknown(SENT),register('Fail in adverbial_phrase',ADVERBIAL),fail}.

/* VOCABULARY */
adverbial_is(X) --> [at,once], {register_found(adverbial,'at once'), 
	retractall(record(_,at)), retractall(record(_,once))}.
adverbial_is(X) --> [out,of,bed], {register_found(adverbial,'out of bed'), 
	retractall(record(_,out)), retractall(record(_,of)), retractall(record(_,bed))}.
adverbial_is(X) --> [from,side,to,side], {register_found(adverbial,'from side to side'),
	retractall(record(_,from)), retractall(record(_,to)), retractall(record(_,side))}.
adverbial_is(X) --> [in,agony], {register_found(adverbial,'in agony'),
	retractall(record(_,in)), retractall(record(_,agony))}.
adverbial_is(X) --> [death], {register_found(adverbial,'death'),
	retractall(record(_,death))}.
adverbial_is(X) --> [out,of,sight], {register_found(adverbial,'out of sight'),
	retractall(record(_,out)), retractall(record(_,of)), retractall(record(_,sight))}.

coord_conj_is(X) --> [CONJ],{coord_conj(CONJ), register_found(coord_conj,CONJ)}.

sub_conj_is(X) --> [SUB],{sub_conj(SUB), register_found(sub_conj,SUB)}.

determiner_is(X) --> [DET],{determiner(DET), register_found(determiner,DET)}.

infinitive_is(X)-->[to,snake,away], {register_found(infinitive,'to snake away'),
	retractall(record(_,to)), retractall(record(_,snake)), retractall(record(_,away))}.
infinitive_is(X)-->[to,twitch], {register_found(infinitive,'to twitch'),
	retractall(record(_,to)), retractall(record(_,twitch))}.
infinitive_is(X)-->[to,quieten], {register_found(infinitive,'to quieten'),
	retractall(record(_,to)), retractall(record(_,quieten))}.
infinitive_is(X)-->[to,kill], {register_found(infinitive,'to kill'),
	retractall(record(_,to)), retractall(record(_,kill))}.

verb_is(X) --> [burst,open], {register_found(verb,'burst open'),
	retractall(record(_,burst)), retractall(record(_,open))}.
verb_is(X) --> [came,back], {register_found(verb,'came back'),
	retractall(record(_,came)), retractall(record(_,back))}.
verb_is(X) --> [came,out], {register_found(verb,'came out'),
	retractall(record(_,came)), retractall(record(_,out))}.
verb_is(X) --> [picked,up], {register_found(verb,'picked up'),
	retractall(record(_,picked)), retractall(record(_,up))}.
verb_is(X) --> [looked,round], {register_found(verb,'looked round'),
	retractall(record(_,looked)), retractall(record(_,round))}.
verb_is(X) --> [VERB],{verb(VERB), register_found(verb,VERB)}.

participle_is(X) --> [PARTICIPLE], {participle(PARTICIPLE), register_found(participle,PARTICIPLE)}.

preposition_is(X) --> [out,of], {register_found(preposition,'out of'),
	retractall(record(_,out)), retractall(record(_,of))}.
preposition_is(X) --> [from,under], {register_found(preposition,'from under'),
	retractall(record(_,from)), retractall(record(_,under))}.
preposition_is(X) --> [PREPOSITION], {preposition(PREPOSITION), register_found(preposition,PREPOSITION)}.

noun_is(X) --> [NOUN], {noun(NOUN), register_found(noun,NOUN)}.

pronoun_is(X) --> [PRONOUN], {pronoun(PRONOUN), register_found(pronoun,PRONOUN)}.

propernoun_is(X) --> [PROPERNOUN], {propernoun(PROPERNOUN), register_found(propernoun,PROPERNOUN)}.

adjective_is(X) --> [ADJECTIVE], {adjective(ADJECTIVE), register_found(adjective,ADJECTIVE)}.

genitive_is(X) --> [GENITIVE], {genitive(GENITIVE), register_found(genitive,GENITIVE)}.

/* END VOCABULARY */

/* PROGRAM TO READ IN A TEXT FILE AND ANALYSE SENTENCES WHILE
   READING IN, USING GETSENT */

/* WINPRO VERSION USING -1 TO END FILE */

/* Reads in a text file using 'getsent', converting each sentence in
   the text to a list of words, saving each list as a 'sentlist' fact.
   Writes sentences out from the lists using 'writesent'. */

dcg:-   put(12),draw_menu,draw_option,
	write('Enter your choice '),get_choice(Choice),
	go_dcg(Choice).

go_dcg(52):-!. /* Exit */
go_dcg(Choice):-nl,write('Checking grammar. Please wait ............'),nl,
	Incorrect is 0,TotalSent is 0, nl,nl,
	File='bond.txt', 
        see(File),
	analyse_dcg(File,Sent,Incorrect,TotalSent,Choice),
	seen.

analyse_dcg(File,Sent,Incorrect,TotalSent,Choice):-
	getsent(File,Sent),not Sent=[eof],
        assertz(sentlist(Sent)),
	tailor(Sent,[],NewSent),
        remove_fullstop(NewSent,Sent2),
        go2_dcg(Sent2,Incorrect,TotalSent,Choice),!.
analyse_dcg(_,[eof],Incorrect,TotalSent,Choice):-ending(Incorrect,TotalSent).

go2_dcg(Sent,Incorrect,TotalSent,Choice):-
	test_dcg(Sent,Incorrect,TotalSent,Choice),!.
go2_dcg(Sent,Incorrect,TotalSent,Choice):-
	write_parse,
	retractall(record(_,_)),
	writesent(Sent),N1 is Incorrect + 1,T1 is TotalSent + 1,
        write('Incorrect grammar.'),nl,nl,analyse_dcg(_,_,N1,T1,Choice).

test_dcg(Sent,Incorrect,TotalSent,49):-phrase(complex_sentence,Sent),
	write_parse,
	writesent(Sent),
	retractall(record(_,_)),
	T1 is TotalSent + 1,
        write('Correct grammar.'),nl,nl,analyse_dcg(_,_,Incorrect,T1,49).

test_dcg(Sent,Incorrect,TotalSent,50):-phrase(complex_sentence,Sent),
	writesent(Sent),
	retractall(record(_,_)),
	T1 is TotalSent + 1,
        write('Correct grammar.'),nl,nl,analyse_dcg(_,_,Incorrect,T1,50).

test_dcg(Sent,Incorrect,TotalSent,51):-phrase(complex_sentence,Sent),
	T1 is TotalSent + 1,retractall(record(_,_)),
        analyse_dcg(_,_,Incorrect,T1,51).

draw_option:-
	write('  1 - Display all sentences with all comment.'),nl,
	write('  2 - Display all sentences with possible grammar mistake.'),nl,
	write('  3 - Display incorrect sentences with possible grammar mistake.'),nl,
	write('  4 - Exit.'),
	nl,nl,nl.

check(49). /* 1 */
check(50). /* 2 */
check(51). /* 3 */
check(52). /* 4 */

/* Record states and parts of sentence */
new_state(Q):-retractall(state(_)),assertz(state(Q)).

register(Part,Word):-retractall(record(Part,Word)),assertz(record(Part,Word)).

register_found(Part,Word):-retractall(record('unknown',Word)),retractall(record(_,Word)),
	assertz(record(Part,Word)),!.

register_unknown(Word):-new_state(notfound),check_unknown(Word),state(notfound),assertz(record(unknown,Word)).

check_unknown(Word):-record(X,Word),new_state(found).
check_unknown(Word):-!.

/* Find last record in the database and store as last(Part,Word) */
findlast:-record(X,Y),
	retractall(last(_,_)),
	assertz(last(X,Y)),fail.
findlast:-!.

/* END */
